perform_simulation <- function(P, N, pex, pim, t_max, disturbance_time=-1, pex_dist=0, classes=1, pex2=NA, pim2=NA, inds=NA) {

   #source("code/r/community_change_functions.r")

   # prescence absence vec
   svec <- mat.or.vec(P,1)

   # time of arrival vec
   tvec <- mat.or.vec(P,1)
   vecs <- list(svec=svec, tvec=tvec)

   # initialize svec
   vecs$svec[1:N] <- 1
   vecs$tvec[1:N] <- 0

   # recaclulate disturb as time from t_max
   t_dist    <- t_max - disturbance_time

   for (i in 1:t_max) {

      if (t_dist == i & pex_dist > 0) {
         vecs <- disturbance( pex_dist, vecs)
      }
      #vecs <- species_specific_constant_rates( pex, pim, vecs, i)
      vecs <- species_specific_constant_rate_classes( pex, pim, vecs, i, classes=classes, pex2=pex2, pim2=pim2, inds=inds)
   }

   t <- (t_max - vecs$tvec + 1)[which(vecs$svec == 1)]
 
   tr <- rev(sort(t))

   if ( any(tr > t_max )) {
      cat("warning: assemblies contains initial species ... \n")
   }

   return(tr)
}

